*************************************
******* Preparting HRS data  ********
*************************************

global workingDir 	"C:\Users\liliy\Dropbox\01_Projects\03_SHARE_CAD_edu_health\04_dofiles\Leopold_2018"

global basis 		"C:\Users\liliy\Dropbox\01_Projects\03_SHARE_CAD_edu_health\04_dofiles\Leopold_2018\Data\SHARE_HRS"   // oirginal SHARE and HRS files

global basishrs		"C:\Users\liliy\Dropbox\01_Projects\03_SHARE_CAD_edu_health\04_dofiles\Leopold_2018\Data\SHARE_HRS\HRS" // oirginal HRS data provided by RAND, the release from 25.09.2014, downloaded from HRS homepage on 29.10.2014


global working 		"${workingDir}/01_working_data"	   // working data - data saved after merging and recodings
global tables 		"${workingDir}/02_tables" 		   // tables 
global graphs 		"${workingDir}/03_graphs" 		   // graphs
global dofiles 		"${workingDir}/04_dofiles" 		   // do-files

clear matrix
set maxvar 10000
 
use $basishrs\rndhrs_n.dta, clear



//Use the RAND HRS File  
clear 
tempfile aux 
use hhidpn inw? inw?? r?iwstat r??iwstat hacohort racohbyr ///
    ragender raracem rabyear rabplace r?cenreg r??cenreg  ///
	radyear raedyrs raedegrm raeduc s6wtresp r6wtresp ///
	r?walk1 r??walk1 r?sit r??sit r?chair r??chair r?clims r??clims ///
	r?clim1 r??clim1 r?stoop r??stoop r?arms r??arms r?push r??push ///
	r?lift r??lift r?dime r??dime r?bmi r??bmi r?smokev r??smokev r?smoken r??smoken ///
	r?dress r??dress r?walkr r??walkr ///
	r?bath r??bath r?eat r??eat r?bed r??bed r?toilt r??toilt ///
	r?map r??map r?meals r??meals r?shop r??shop r?phone r??phone r?meds r??meds ///
	r?money r??money ///
	r?hibpe r??hibpe r?diabe r??diabe r?cancre r??cancre ///
	r?lunge r??lunge r?stroke r??stroke r?arthre r??arthre  r?lgmusa  r??lgmusa ///
	using $basishrs/rndhrs_n.dta, clear
save `aux', replace

// rename variables for reshape
// here you might get an error message "## not allowed in oldname..." after each second raw. Just go on with the next two afterwards.

rename r#walk1 rwalk1#
rename r##walk1 rwalk1## 

rename r#sit rsit#
rename r##sit rsit##

rename r#chair rchair#
rename r##chair rchair##

rename r#clims rclims#
rename r##clims rclims##

rename r#clim1 rclim1#
rename r##clim1 rclim1#

rename r#stoop rstoop#
rename r##stoop rstoop## 

rename r#arms rarms#
rename r##arms rarms##

rename r#push rpush#
rename r##push rpush#

rename r#lift rlift#
rename r##lift rlift##

rename r#dime rdime#
rename r##dime rdime##

rename r#hibpe rhibpe#
rename r##hibpe rhibpe##

rename r#diabe rdiabe# 
rename r##diabe rdiabe## 

rename r#cancre rcancre# 
rename r##cancre rcancre## 

rename r#lunge rlunge#
rename r##lunge rlunge##

rename r#stroke rstroke#
rename r##stroke rstroke##

rename r#arthre rarthre#
rename r##arthre rarthre##

rename r#cenreg rcenreg#
rename r##cenreg rcenreg##

rename r#iwstat riwstat#
rename r##iwstat riwstat##

rename r#lgmusa  rlgmusa#
rename r##lgmusa  rlgmusa##

rename r#dress rdress#
rename r##dress rdress##

rename r#walkr rwalkr#
rename r##walkr rwalkr##

rename r#bath rbath#
rename r##bath rbath##

rename r#eat reat#
rename r#eat reat##

rename r#bed rbed#
rename r#bed rbed##

rename r#toilt rtoilt#
rename r##toilt rtoilt##

rename r#bmi rbmi#
rename r##bmi rbmi##

rename r#smokev rsmokev#
rename r##smokev rsmokev##

rename r#smoken rsmoken#
rename r##smoken rsmoken##


***********************************************

//rehshape to long format:

reshape long inw riwstat ///
			 rhibpe rdiabe rcancre ///
	         rlunge rstroke rarthre ///
	         rcenreg ///
			 rwalk1 rsit rchair rclims rclim1 rstoop rarms rpush rlift rdime ///
			 rlgmusa rbmi rsmokev rsmoken, ///
i(hhidpn) j(wave)

************************************************

* save hrs long
save $working\hrs_long, replace


****************************************************
****************************************************
*** PREPARATION OF THE COMPARATIVE FILE ************
****************************************************
****************************************************

use $working\hrs_long, clear

*** id the same name as in SHARE

tostring hhidpn, gen(mergeid)

***** svyear

gen svyear=.
replace svyear=2004 if wave==7
replace svyear=2006 if wave==8
replace svyear=2008 if wave==9
replace svyear=2010 if wave==10
replace svyear=2012 if wave==11


************************************************
*****Died

bys mergeid (svyear): gen auxdied =  riwstat ==6 
bys mergeid (svyear): egen died =  max(auxdied)

***** Year of death

clonevar diedy = radyear

bys mergeid (svyear): gen auxsvyear_died= svyear if riwstat ==6 
bys mergeid (svyear): egen svyear_died =  max(auxsvyear_died)

replace diedy = svyear_died if diedy==.

************************************************
* Only actual observations, not only potential

gen aux = wave if inw == 1

bysort hhidpn (wave): egen lastwave = max(aux)
label var lastwave "First wave respondent participated in HRS (wo censoring)"

bysort hhidpn (wave): egen realfirstwave = min(aux)
label var realfirstwave "First wave respondent participated in HRS (wo censoring)"

*** drop so that only if resondent actually participated in a wave he or she has a value for that wave

drop if wave!=aux

drop if realfirstwave >7 // only those who were part of the sample in 2004

drop if wave<7


******
recode wave (7=1) (8=2) (9=3) (10=4) (11=5)



*** Age in 2004

gen age_w1 = 2004- rabyear

drop if age_w1 <50 // only the sample 50+
drop if age_w1 >65 // only the sample until 65 at the first wave (= 80 at the last wave)

*** Age in years

gen age_years = svyear - rabyear

****************************
**** Edu cat ***************

clonevar edu_cat_=raedegrm

gen edu=.
replace edu=1 if  edu_cat_<=2
replace edu=2 if  edu_cat_==3 | edu_cat_==4
replace edu=3 if  edu_cat_>=5

tabulate edu, gen(edu_)


*********************
*chonic conditions **
*********************

egen chron_hrs5=anycount( rhibpe rdiabe rcancre rstroke rlunge), v(1)

egen miss_ch5=rowmiss(rhibpe rdiabe rcancre rstroke rlunge )

replace chron_hrs5 =. if chron_hrs==0 & miss_ch==5


egen chron_hrs4=anycount( rhibpe rdiabe rstroke rlunge), v(1)

egen miss_ch4=rowmiss(rhibpe rdiabe rstroke rlunge )

replace chron_hrs4 =. if chron_hrs4==0 & miss_ch4==4


*************************************
* Chronic conditions  ***************
*************************************

gen high_BP = rhibpe ==1 & rhibpe!=.
 
replace high_BP =. if rhibpe ==.

gen stroke = rstroke==1

gen diabet = rdiabe==1
gen cancer = rcancre==1
gen lung_di = rlunge==1
gen artr = rarthre==1


*****************************************
* Functional limitations ****************
*****************************************

foreach var of varlist rwalk1 rsit rchair rclims rclim1 rstoop rarms rpush rlift rdime {
			  replace `var'=. if `var'>1
}

egen mobility=anycount(rwalk1 rsit rchair rclims rclim1 rstoop rarms rpush rlift rdime), v(1)
egen miss_mobility=rowmiss(rwalk1 rsit rchair rclims rclim1 rstoop rarms rpush rlift rdime)

replace mobility=. if mobility==0 & miss_mobility==10

gen mob_2=mobility>=2
replace mob_2=. if mobility==.

gen mob_3=mobility>=3
replace mob_3=. if mobility==.


gen walk   = rwalk1 ==1
gen sit    = rsit   ==1
gen chair  = rchair ==1
gen stair  = rclims ==1
gen stair1 = rclim1 ==1
gen stoop  = rstoop ==1
gen arms   = rarms  ==1
gen push   = rpush  ==1
gen lift   = rlift  ==1
gen dime   = rdime  ==1


* large muscles

clonevar lgmuscle = rlgmusa


*********************
*** Controls ********
*********************

***** gender

rename ragender gender

gen male=gender==1
label variable male "Male"

***** year of birth

rename rabyear yrbirth
drop if yrbirth==.m

* age

gen age = svyear - yrbirth

gen age_c= age-50

gen age_2 = age * age

sum age_2

gen age_2_c = age_2 - r(mean)

gen aux_age_w1 = 2004-yrbirth
gen age_w1_c = aux_age_w1-50


*** n

bysort mergeid (wave): gen n=_n

	

*region

clonevar region=rcenreg

tabulate region, gen (region_)

lab var region_1 "northeast"
lab var region_2 "midwest"
lab var region_3 "south"
lab var region_4 "west"
lab var region_5 "other"

gen south = region==3

*race

clonevar race=raracem

gen white=(race==1)
gen black=(white!=1)

*place of birth 

clonevar immig=rabplace

***** Drop immigrants

drop if immig==11

************************
*** sampling weight   **
************************

// after the publication I detected a mistake in the code: 
// I used a wrong weighting variable - s6wtresp instead of the right one - r6wtresp
// to replicate the initially published analyses, please use the s6wtresp'
// to replicate the correct analyses, which I will submit as an erratum to Demography as soon as possible
// please use r6wtresp

gen samp_weight = s6wtresp

*gen samp_weight = r6wtresp
 
***********************

gen bmi = rbmi
replace bmi =. if rbmi==.m | rbmi==.r
gen smokev = rsmokev
replace smokev =. if rsmokev==.m 
gen smoken = rsmoken
replace smoken = . if rsmoken == .d | rsmoken==.m

 
***********************
*** DROPOUTS **********
***********************

gen dropout = lastwave<11

gen us=1

*********************************
*** Save the data ***************

save $working\hrs_cr.dta, replace



				
		
